/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Vacuum Places Improved.
 *
 * The Initial Developer of the Original Code is
 * Luca Niccoli <lultimouomo@gmail.com>.
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var VacuumPlacesImproved = {
    Load : function(){
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                           .getService(Components.interfaces.nsIWindowMediator);
        var enumerator = wm.getEnumerator(null);
        var openWindows  = 0;
        while(enumerator.hasMoreElements()) {
            openWindows++;
            enumerator.getNext();
        }
        if (openWindows == 1) {
            VacuumPlacesImproved.SetStartNumber(VacuumPlacesImproved.GetStartNumber()+1);
        }
        VacuumPlacesImproved.Reload();
    },

    Reload : function(){
        var hide = (VacuumPlacesImproved.AutoHide() == true
                   && VacuumPlacesImproved.GetStartNumber() < VacuumPlacesImproved.HideInterval());
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                           .getService(Components.interfaces.nsIWindowMediator);
        var enumerator = wm.getEnumerator('navigator:browser');
        while(enumerator.hasMoreElements()) {
             var oneWindow = enumerator.getNext();
             oneWindow.document.getElementById('VPIpanel').hidden = hide;
        }
        if (VacuumPlacesImproved.AutoClean() == true
           && VacuumPlacesImproved.GetStartNumber() >= VacuumPlacesImproved.CleanInterval()){
            VacuumPlacesImproved.Clean();
        }
    },

    LeftClick : function(e){
        if (e.button == 0){
            VacuumPlacesImproved.Clean();
        }
    },

    Clean : function(){
            Components.classes["@mozilla.org/browser/nav-history-service;1"]
                      .getService(Components.interfaces.nsPIPlacesDatabase)
                      .DBConnection.createStatement("VACUUM")
                      .executeAsync({
                handleCompletion: function(aReason){
                    if (aReason == Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
                        var VPIstrings = document.getElementById("VPIstrings");
                        var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
                                                      .getService(Components.interfaces.nsIAlertsService);
                        alertsService.showAlertNotification("chrome://VacuumPlacesImproved/content/VPI-32.png",
                                                            VPIstrings.getString("VPI"),
                                                            VPIstrings.getString("placesVacuumed"),
                                                            false,
                                                            "vacuumed",
                                                            null);
                        VacuumPlacesImproved.SetStartNumber(0);
                        VacuumPlacesImproved.Reload();},
                handeError: function(aError) {throw aError;},
                handleResult: function(aResultSet){throw "UnexpectedSQLResult";}
            });

    },

    ShowPrefs : function(){
        window.open("chrome://VacuumPlacesImproved/content/preferences.xul",
                          "_blank",
                          "centerscreen,chrome");
    },

    /* All the following methods are for getting and setting preferences */
    
    GetStartNumber : function(){
        return Components.classes["@mozilla.org/preferences-service;1"]
                         .getService(Components.interfaces.nsIPrefService)
                         .getBranch("extensions.VacuumPlacesImproved.")
                         .getIntPref("startnumber");
    },

    SetStartNumber : function(number){
         Components.classes["@mozilla.org/preferences-service;1"]
                   .getService(Components.interfaces.nsIPrefService)
                   .getBranch("extensions.VacuumPlacesImproved.")
                   .setIntPref("startnumber", number);
    },

    HideInterval : function(){
         return Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefService)
                          .getBranch("extensions.VacuumPlacesImproved.")
                          .getIntPref("hideinterval");
    },

    AutoHide : function(){
         return Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefService)
                          .getBranch("extensions.VacuumPlacesImproved.")
                          .getBoolPref("autohide");
    },

    CleanInterval : function(){
        return Components.classes["@mozilla.org/preferences-service;1"]
                         .getService(Components.interfaces.nsIPrefService)
                         .getBranch("extensions.VacuumPlacesImproved.")
                         .getIntPref("cleaninterval");
    },

    AutoClean : function(){
         return Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefService)
                          .getBranch("extensions.VacuumPlacesImproved.")
                          .getBoolPref("autoclean");
    }
};

window.addEventListener("load",
                        function(){VacuumPlacesImproved.Load();},
                        false);


